#!/usr/bin/perl

# Copyright (c) 2001-2003, RedIRIS. All Rights Reserved.
#
# You may distribute under the terms of either the GNU General Public License
# or the Artistic License, as specified in the LICENSE file that was shipped
# with this distribution.
use PAPI::Config;
use Data::Dumper;
use Apache2::Directive; 

#
## Important!! 
#
## These variables must be defined as local, because the mod_perl parser
## recognices any no local variable as a variable for set the Apache directives.
#  
my $i = 0;
my @apacheConf = ();
my $subSectionCont = 0;
my $servers = 0;
my $PoAconf = undef;
my $xmlChecker = 1;

#

#
#
## Read the PAPI XML config file.
#
if (defined($ENV{XML_CHECKER_ACTIVE})) {
  if ($ENV{XML_CHECKER_ACTIVE} eq 'false'){
    $xmlChecker = 0;
  }
}else{
  print "\nThe XML_CHECKER_ACTIVE Perl enviroment variable is not defined.";
  print "\nPAPI will icheck the xml configuration file again the DTD\n\n";
}



my $aux = new PAPI::Config();
my $res=$aux->load_conf("$ENV{PoA_CONFIG_FILE}",$xmlChecker);
if ( $res eq "ERROR" ){
  return(0)
}

$aux->flat_conf();
$PAPI::Config::Global = $aux->trans_conf();
$PoAconf = $PAPI::Config::Global;
#print Dumper($PoAconf);
#exit(0);

if ( defined($ENV{CONFIG_VERBOSE}) && ($ENV{CONFIG_VERBOSE} eq 'true') ){
  #$PAPI::Config::Global->print_conf();
  $PoAconf->print_conf();
}

print "PAPI supposes that all protected resources are defined in Apache httpd.conf file\n";
print "Checking the sections for those resources....\n"; 
my $checkResult = checkSections($PoAconf);
if ($checkResult ne 'OK'){
  print "+----------------------------------------------------------------------+\n";
  print "|\n";
  print "| Error detected in the PAPI configuration....\n";
  print "| The next sections are not defined in the PAPI XML configuration file.\n";
  print "| So their resources will be not protected\n";
  print "|\n";
  print "| Server : Type : Path : Service_ID\n";
  print "|\n";
  print "$checkResult";
  print "|\n";
  print "| Apache is going to start OK, but may be exits security holes in PAPI\n";
  print "| protection.\n";
  print "+----------------------------------------------------------------------+\n";
}else{
  print "OK\n";
}



#------------------------------------------------------------------------------#
#
#   Functions.
#
#------------------------------------------------------------------------------#

#
## The doc for this function is TODO.
#
sub checkSections{
	my $conf 				= shift;
  my @sections		= ();
  my $tree				= Apache2::Directive::conftree();
  my $node				= $tree;
  my $sectionsNOK ="";

  while (defined($node)){
    processNode($node,\@sections);
    $node = $node->next();
  }       

  matchSections($conf, \@sections);
  
  foreach my $sec (@sections){
  	if ( $sec !~ /:OK$/ ){
  		$sectionsNOK .= "| ".$sec."\n";
  	}
  }
  if($sectionsNOK eq ""){
  	$sectionsNOK = 'OK';
  }
  return ($sectionsNOK);
}

#
## The doc for this function is TODO.
#
sub processNode{
    my $node = shift;
    my $sections = shift;
    my $directiv = $node->directive();

    if(defined($directiv) && $directiv =~ /<VirtualHost/){
      my $subSection = $node->first_child();
      do{
					if (undef != $subSection){
						print "Directiva en VH: ".$subSection->directive()."\n" if ($ENV{CONFIG_DEVELOP} == 2);
      	  	if ( $subSection->directive() =~ '<Location'
           		|| $subSection->directive() =~ '<Directory'
							|| $subSection->directive() =~ '<Files')
						{
							print "\tArgumentos : ".$subSection->args()."\n\t\t".$subSection->as_string()."\n\n" if ($ENV{CONFIG_DEVELOP} > 1);
							my @argsAUX = split("\n",$subSection->as_string());
							ARGS: foreach(@argsAUX){
								if ($_ =~ /^PerlSetVar/m){
									my @tempAUX = split(' ',$_);
									my $serviceID = $tempAUX[2];
  		  	      	my $path = $subSection->args();
  		  	      	my $type = $subSection->directive();
  		  	      	$path =~s/"|>//g;
  		  	      	$type =~ s/^<//;
        	    		$node->as_string() =~/^ServerName (.*)/m;
        	    	
        	    		my $resource = $1.':'.$type.':'.$path.':'.$serviceID;
            		
            			print ("Adding from VirtualHost: $resource\n") if ($ENV{CONFIG_DEVELOP}  > 0) ;
            			push (@{$sections}, $resource);
									last ARGS;
								}	
              }
          	}
          }
          $subSection = $subSection->next();
        }while(undef != $subSection);
    }elsif ($directiv =~/<Location/
    		 || $directiv =~ /<Directory/
				 || $directiv =~ /<Files/){
      if ($node->as_string() =~ m/^PerlSetVar\s+Service_ID\s+(\w*)/m){
				my $serviceID = $1;
  		  my $path = $node->args();
  		  my $type = $node->directive();
  		  my $aux = Apache2::Directive::conftree();
 		  	my $srvName = $aux->lookup('ServerName');
  		  $path =~s/"|>//g;
  		  $type =~ s/^<//;
 	    	my $resource = 'Main'.':'.$type.':'.$path.':'.$serviceID;
        print ("Adding from Main: $resource\n") if ($ENV{CONFIG_DEVELOP}  > 0);
        push (@{$sections}, $resource);
      }
    }
    
   # my $child = $node->first_child();
   # if (defined($child)){
   #     processNode($child,$section);
   # }else{
   #     my $parent = $node->parent();
   #     my $next = $node->next();
   #     if (defined($parent) && defined($next)){
   #         processNode($next,$section);
   #     }
   # }
}

#
## This function match the protected by PAPI sections defined in httpd.conf,
## with the onces that are defined in the PAPI XML configuration file.
##
##  Input parms:
##      $conf is the PAPI::Config::Global variable
##
##	I/O parms:
##      $sec is a reference to an array that has the names of the sections
##        defined in httpd.conf, the right sections will be marked with OK
##				and thr wrong ones that no exist at httpd.conf file will be added.
#
sub matchSections{
  my ($conf, $sec) = @_;
  my $server = '';
  my $resource;
  my $ok = 0;
  print "\nMatching Sections\n" if ($ENV{CONFIG_DEVELOP} >= 1);
  
  #print Dumper($conf)."\n";
  for my $s (sort (keys %{$conf})){		
		if ( $s eq 'Global' ){
			$server = 'Main';
		}else{
			$server = $s;
		}
    
    for my $elem ( keys(%{$conf->{$s}}) ){
    	#print "\t<$s><$elem><".$conf->{$s}{$elem}{'Type'}.">\n" if ($ENV{CONFIG_DEVELOP} >= 1);
    	if ( (ref($conf->{$s}{$elem}) eq "HASH") && ($conf->{$s}{$elem}{'Type'} =~ /Location|Directory|Files/) ){
				$resource = "$server:$conf->{$s}{$elem}{Type}:$conf->{$s}{$elem}{String}:$conf->{$s}{$elem}{Serv}";
    		#$resource = "$server:$elem->{Type}:$elem->{String}:$elem->{Serv}";
    		print "Adding from XML: $resource\n" if ($ENV{CONFIG_DEVELOP} >= 1);
    		$ok=0;
    		for ($i=0; $i < @{$sec}; $i++){
    			#print "test $i: ".${$sec}[$i]."\n" if ($ENV{CONFIG_DEVELOP} >= 1);
    			if ($resource eq ${$sec}[$i]){
    				${$sec}[$i] .= ":OK";
    				$ok=1;
    			}
    		}
    		if (!$ok){
   				push(@{$sec}, "XML:".$resource);
    		}
    	}
    }
  }
}

#
## This funtions remove the elementes between the second and third parameters
## from the array passed as the first parameter.
##
## Input parameters:
##      $array: A reference to an array. It will be changed.
##      $i: The first index. The element indexed by $i will be removed. 
##      $j: The second index. The elements from $i to the one indexed by $j will
##          be removed.
## Output parameters:
##      $array: Is an I/O parm.
#
sub trueSplice {

  my $vector = shift;
  my $i = shift;
  my $j = shift;
  my $k = 0;
  my $toRemove = $j - $i + 1;

  for ( $k = 0; $k < @{$vector}; $k++){
    if ($k >= $i){
      @{$vector}[$i] = @{$vector}[$j+1];
      $i++;
      $j++;
    }
  }

  @{$vector} = @{$vector}[0 .. (@{$vector} - $toRemove)];
}


#
## The doc for this function is TODO. 
#
sub setupVH {
  my $conf = shift;

  for my $s (sort (keys %{ $conf})){
    if ( ($s eq "Main") || ($s eq "Global") ){
      next;
    }
        
    # Hash reference for the virtual servers. For each iteration it mus be empty.
    my $newServerConf = {};
       
    # each element of @{ $conf->{$s}} is a reference of an array.
    for my $elem ( @{ $conf->{$s}} ){
      # Get the hash arrays.
      # If the hash array Type is "Server", and no are processing once yet,
      #make a new "VirtualServer" entry.
      if ($elem->{Type} eq "Server" && $servers == 0){
        $servers = 1;
                   
        $newServerConf->{VirtualHost} = $s.":".$elem->{port};
        $newServerConf->{'ServerName'} = $s;
                
        # Process all Apache_Tags elements.
        my @aux = split ("\n", $elem->{Apache_Tags});
        for ( $i=0; $i<=$#aux; $i++){
          # Remove the format of the elements.
          $aux[$i] =~ s/\n|\t+//g;
          my @aux2 = split (" ", $aux[$i]);
                    
          my $size = scalar(@aux2);
          my $clave = 	shift @aux2;
          my $cadena = join (" ", @aux2);
                    
          $newServerConf->{$clave} = $cadena;
        }
      }elsif( ($elem->{Type} eq "Server") && ($servers == 1) ){
        # If the hash array Type is "Server" and are still processing once
        # dump the config of the procesed element, and make a new "Virtual Server" entry
           
        push @apacheConf, $newServerConf;
                            
        $servers = 0;	# This is not needed, but makes the code clearer.
        $subSectionCont = 0;
    
        $servers = 1;	# This is not needed, but makes the code clearer.
                
        # Empty the server data structures.
        $newServerConf = ();
                
        $newServerConf->{VirtualHost} = $s.":".$elem->{port};
        $newServerConf->{ServerName} = $s;
                
      }elsif ( ($elem->{Type} eq "Location") || ($elem->{Type} eq "Files") || ($elem->{Type} eq "Directory") ){
        # Make the subsetions of the virtual Servers entryes
        # If the subsections type is Location, File o Directory.
        $newServerConf->{"subSection $subSectionCont"}{Type} = $elem->{Type};
        $newServerConf->{"subSection $subSectionCont"}{Path} = $elem->{String};
        $newServerConf->{"subSection $subSectionCont"}{SetHandler} = "perl-script";
          
        if ( $elem->{Filtered}){
          $newServerConf->{"subSection $subSectionCont"}{PerlsetVar} = "Service_ID $elem->{Serv}";
          $newServerConf->{"subSection $subSectionCont"}{PerlOptions} = "+ParseHeaders";
          $newServerConf->{"subSection $subSectionCont"}{PerlAccessHandler} = "PAPI::Main";
        }
        if ( ( (defined $elem->{Remote_Serv}) && ($elem->{Remote_Serv} ne "") ) ||
           ( (defined $elem->{Remote_Dom}) && ($elem->{Remote_Dom} ne "") ) ){
          $newServerConf->{"subSection $subSectionCont"}{PerlsetVar} = "Service_ID $elem->{Serv}";	 	
          $newServerConf->{"subSection $subSectionCont"}{PerlAccessHandler} = "PAPI::Main";
          $newServerConf->{"subSection $subSectionCont"}{PerlResponseHandler} = "PAPI::RewritingProxy";			
        }
        $subSectionCont++;
      }
    }

    # Dump the config of the last procesed element. Perhaps this is not needed
    # but i keep it.
    if ($servers == 1){
      push @apacheConf, $newServerConf;
      $servers = 0;	# This is not needed, but makes the code clearer.
      $subSectionCont = 0;
    }
  }
  # Pass to Apache the configuration directives.
    
  # Static declared.
  # This statement must be declared at Apache2 configuration file.
  # It is due to "MAIN HOST GOES AWAY" see Apache 2.X Doc
  # http://httpd.apache.org/docs/2.0/en/vhosts/name-based.html
  ## $NameVirtualHost = '*:80';

  # Apache waits somethin like this:
  #
  #$VirtualHost{"host.subdom.dom:port"} = {
  #	ServerName => 'host.subdom.dom:port',
  #	DocumentRoot => "/usr/local/apache/htdocs",
  #	ErrorLog => "logs/poa2_errors_log",
  #	CustomLog => "logs/poa2_acces_log common",
  #	Location => {
  #		"/Resource/" => {
  #			SetHandler => "perl-script",
  #			PerlSetVar => "ServiceIN rootWeb",
  #			PerlAccessHandler => "PAPI::Main",
  #			PerlOptions => "+ParseHeaders",
  #		}
  #	}
  #};
   
  # $VirtualHost statement cannot have the port number static 
  # replace it by... $VirtualHost{'*:$PORT'}
   
  my $arrayRef = [];
  $VirtualHost{'*'} = $arrayRef;
  foreach my $serv (@apacheConf){
    my %virtualHostHash;
    
    for my $key (keys %{$serv}){
      if (ref($serv->{$key}) eq "HASH"){
        my %locHash;
        my %pathHash;
                
        my $path = $serv->{$key}{'Path'};
        my $tipo = $serv->{$key}{'Type'};
              
        for my $subKey (keys %{$serv->{$key}}){
          if ($subKey eq "Type" || $subKey eq "Path"){
            next;
          }else{
            $pathHash{$subKey} = %{$serv}->{$key}->{$subKey};
          }
        }
        $locHash{$path} = \%pathHash;
        $virtualHostHash{$tipo} = \%locHash;
      }elsif ($key eq "VirtualHost"){
        next;		    
      }else{
        $virtualHostHash{$key} = $serv->{$key}; 
      }
    }
        
    my $refVHH = \%virtualHostHash;
    push @{$VirtualHost{'*'}}, $refVHH;
  }
}

#
## This function is only for Debug. Remove it from the final versión.
#
sub pintaNodo {
  my $nodo = shift;
  my $deep = shift;
  
  my $directiva = $nodo->directive();
  my $args = $nodo->args();
  my @aux = split('<',$directiva);
  my $finDirectiva = "</".$aux[1].">";
  my $tabs = '';
  my $i = $deep;
  
  while ($i > 0 ){
    $tabs .= "\t";
    $i--;
  }
  
  print $tabs."$directiva $args\n";
  if (my $hijo = $nodo->first_child()){
    pintaNodo($hijo,++$deep);
    $deep--;
    print $tabs."$finDirectiva\n";
  }else{
    my $padre = $nodo->parent();
    my $sig = $nodo->next();
    if ( defined($padre) && defined($sig) ){
      pintaNodo($sig,$deep);
    }
  }
}
1;
#_END_
